Index: trunk/mkspecs/os2-g++/qplatformdefs.h
===================================================================
--- trunk/mkspecs/os2-g++/qplatformdefs.h	(revision 658)
+++ trunk/mkspecs/os2-g++/qplatformdefs.h	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the qmake spec of the Qt Toolkit.
Index: trunk/qmake/generators/os2/gnumake.cpp
===================================================================
--- trunk/qmake/generators/os2/gnumake.cpp	(revision 658)
+++ trunk/qmake/generators/os2/gnumake.cpp	(revision 659)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
@@ -7,5 +7,5 @@
 ** This file is part of the qmake application of the Qt Toolkit.
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** $QT_BEGIN_LICENSE:LGPL$
Index: trunk/qmake/generators/os2/gnumake.h
===================================================================
--- trunk/qmake/generators/os2/gnumake.h	(revision 658)
+++ trunk/qmake/generators/os2/gnumake.h	(revision 659)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
@@ -7,5 +7,5 @@
 ** This file is part of the qmake application of the Qt Toolkit.
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** $QT_BEGIN_LICENSE:LGPL$
Index: trunk/src/corelib/global/qt_os2.h
===================================================================
--- trunk/src/corelib/global/qt_os2.h	(revision 658)
+++ trunk/src/corelib/global/qt_os2.h	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtCore module of the Qt Toolkit.
Index: trunk/src/corelib/io/qfilesystemwatcher_os2.cpp
===================================================================
--- trunk/src/corelib/io/qfilesystemwatcher_os2.cpp	(revision 658)
+++ trunk/src/corelib/io/qfilesystemwatcher_os2.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtCore module of the Qt Toolkit.
Index: trunk/src/corelib/io/qfilesystemwatcher_os2_p.h
===================================================================
--- trunk/src/corelib/io/qfilesystemwatcher_os2_p.h	(revision 658)
+++ trunk/src/corelib/io/qfilesystemwatcher_os2_p.h	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtCore module of the Qt Toolkit.
Index: trunk/src/corelib/io/qfsfileengine_iterator_os2.cpp
===================================================================
--- trunk/src/corelib/io/qfsfileengine_iterator_os2.cpp	(revision 658)
+++ trunk/src/corelib/io/qfsfileengine_iterator_os2.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtCore module of the Qt Toolkit.
Index: trunk/src/corelib/io/qfsfileengine_os2.cpp
===================================================================
--- trunk/src/corelib/io/qfsfileengine_os2.cpp	(revision 658)
+++ trunk/src/corelib/io/qfsfileengine_os2.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtCore module of the Qt Toolkit.
Index: trunk/src/corelib/io/qprocess_os2.cpp
===================================================================
--- trunk/src/corelib/io/qprocess_os2.cpp	(revision 658)
+++ trunk/src/corelib/io/qprocess_os2.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtCore module of the Qt Toolkit.
Index: trunk/src/corelib/io/qsettings_os2.cpp
===================================================================
--- trunk/src/corelib/io/qsettings_os2.cpp	(revision 658)
+++ trunk/src/corelib/io/qsettings_os2.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtCore module of the Qt Toolkit.
Index: trunk/src/corelib/kernel/qcoreapplication_pm.cpp
===================================================================
--- trunk/src/corelib/kernel/qcoreapplication_pm.cpp	(revision 658)
+++ trunk/src/corelib/kernel/qcoreapplication_pm.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtCore module of the Qt Toolkit.
Index: trunk/src/corelib/kernel/qeventdispatcher_pm.cpp
===================================================================
--- trunk/src/corelib/kernel/qeventdispatcher_pm.cpp	(revision 658)
+++ trunk/src/corelib/kernel/qeventdispatcher_pm.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtCore module of the Qt Toolkit.
Index: trunk/src/corelib/kernel/qeventdispatcher_pm_p.h
===================================================================
--- trunk/src/corelib/kernel/qeventdispatcher_pm_p.h	(revision 658)
+++ trunk/src/corelib/kernel/qeventdispatcher_pm_p.h	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtCore module of the Qt Toolkit.
Index: trunk/src/corelib/kernel/qpmobjectwindow_pm_p.h
===================================================================
--- trunk/src/corelib/kernel/qpmobjectwindow_pm_p.h	(revision 658)
+++ trunk/src/corelib/kernel/qpmobjectwindow_pm_p.h	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtCore module of the Qt Toolkit.
Index: trunk/src/corelib/plugin/qlibrary_os2.cpp
===================================================================
--- trunk/src/corelib/plugin/qlibrary_os2.cpp	(revision 658)
+++ trunk/src/corelib/plugin/qlibrary_os2.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /***************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtCore module of the Qt Toolkit.
Index: trunk/src/corelib/thread/qmutex_os2.cpp
===================================================================
--- trunk/src/corelib/thread/qmutex_os2.cpp	(revision 658)
+++ trunk/src/corelib/thread/qmutex_os2.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtCore module of the Qt Toolkit.
Index: trunk/src/corelib/thread/qthread_os2.cpp
===================================================================
--- trunk/src/corelib/thread/qthread_os2.cpp	(revision 658)
+++ trunk/src/corelib/thread/qthread_os2.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtCore module of the Qt Toolkit.
Index: trunk/src/corelib/thread/qwaitcondition_os2.cpp
===================================================================
--- trunk/src/corelib/thread/qwaitcondition_os2.cpp	(revision 658)
+++ trunk/src/corelib/thread/qwaitcondition_os2.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtCore module of the Qt Toolkit.
Index: trunk/src/corelib/tools/qstring.cpp
===================================================================
--- trunk/src/corelib/tools/qstring.cpp	(revision 658)
+++ trunk/src/corelib/tools/qstring.cpp	(revision 659)
@@ -4654,6 +4654,6 @@
     if (localeObj) {
         // note: we assume that data1 and data2 are zero-terminated (to avoid
-        // creation of dumb deep copies) which is at least true for <= 4.6.1.
-#if QT_VERSION <= 0x040601
+        // creation of dumb deep copies) which is at least true for <= 4.6.x.
+#if QT_VERSION < 0x040700
         return UniStrcoll(localeObj, (UniChar*)data1, (UniChar *)data2);
 #else
Index: trunk/src/gui/image/qpixmap_pm.cpp
===================================================================
--- trunk/src/gui/image/qpixmap_pm.cpp	(revision 658)
+++ trunk/src/gui/image/qpixmap_pm.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtGui module of the Qt Toolkit.
Index: trunk/src/gui/kernel/qapplication_pm.cpp
===================================================================
--- trunk/src/gui/kernel/qapplication_pm.cpp	(revision 658)
+++ trunk/src/gui/kernel/qapplication_pm.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtGui module of the Qt Toolkit.
Index: trunk/src/gui/kernel/qclipboard_pm.cpp
===================================================================
--- trunk/src/gui/kernel/qclipboard_pm.cpp	(revision 658)
+++ trunk/src/gui/kernel/qclipboard_pm.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtGui module of the Qt Toolkit.
Index: trunk/src/gui/kernel/qcursor_pm.cpp
===================================================================
--- trunk/src/gui/kernel/qcursor_pm.cpp	(revision 658)
+++ trunk/src/gui/kernel/qcursor_pm.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtGui module of the Qt Toolkit.
Index: trunk/src/gui/kernel/qdesktopwidget_pm.cpp
===================================================================
--- trunk/src/gui/kernel/qdesktopwidget_pm.cpp	(revision 658)
+++ trunk/src/gui/kernel/qdesktopwidget_pm.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtGui module of the Qt Toolkit.
Index: trunk/src/gui/kernel/qdnd_pm.cpp
===================================================================
--- trunk/src/gui/kernel/qdnd_pm.cpp	(revision 658)
+++ trunk/src/gui/kernel/qdnd_pm.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtGui module of the Qt Toolkit.
Index: trunk/src/gui/kernel/qkeymapper_pm.cpp
===================================================================
--- trunk/src/gui/kernel/qkeymapper_pm.cpp	(revision 658)
+++ trunk/src/gui/kernel/qkeymapper_pm.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtGui module of the Qt Toolkit.
Index: trunk/src/gui/kernel/qmime_pm.cpp
===================================================================
--- trunk/src/gui/kernel/qmime_pm.cpp	(revision 658)
+++ trunk/src/gui/kernel/qmime_pm.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtGui module of the Qt Toolkit.
Index: trunk/src/gui/kernel/qsound_pm.cpp
===================================================================
--- trunk/src/gui/kernel/qsound_pm.cpp	(revision 658)
+++ trunk/src/gui/kernel/qsound_pm.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtGui module of the Qt Toolkit.
Index: trunk/src/gui/kernel/qwidget_pm.cpp
===================================================================
--- trunk/src/gui/kernel/qwidget_pm.cpp	(revision 658)
+++ trunk/src/gui/kernel/qwidget_pm.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtGui module of the Qt Toolkit.
Index: trunk/src/gui/kernel/qwindowdefs_pm.h
===================================================================
--- trunk/src/gui/kernel/qwindowdefs_pm.h	(revision 658)
+++ trunk/src/gui/kernel/qwindowdefs_pm.h	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtGui module of the Qt Toolkit.
Index: trunk/src/gui/painting/qcolormap_pm.cpp
===================================================================
--- trunk/src/gui/painting/qcolormap_pm.cpp	(revision 658)
+++ trunk/src/gui/painting/qcolormap_pm.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtGui module of the Qt Toolkit.
Index: trunk/src/gui/painting/qpaintdevice_pm.cpp
===================================================================
--- trunk/src/gui/painting/qpaintdevice_pm.cpp	(revision 658)
+++ trunk/src/gui/painting/qpaintdevice_pm.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtGui module of the Qt Toolkit.
Index: trunk/src/gui/painting/qprinterinfo_pm.cpp
===================================================================
--- trunk/src/gui/painting/qprinterinfo_pm.cpp	(revision 658)
+++ trunk/src/gui/painting/qprinterinfo_pm.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtGui module of the Qt Toolkit.
Index: trunk/src/gui/painting/qregion_pm.cpp
===================================================================
--- trunk/src/gui/painting/qregion_pm.cpp	(revision 658)
+++ trunk/src/gui/painting/qregion_pm.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtGui module of the Qt Toolkit.
Index: trunk/src/gui/text/qfont_pm.cpp
===================================================================
--- trunk/src/gui/text/qfont_pm.cpp	(revision 658)
+++ trunk/src/gui/text/qfont_pm.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtGui module of the Qt Toolkit.
Index: trunk/src/gui/text/qfontdatabase_pm.cpp
===================================================================
--- trunk/src/gui/text/qfontdatabase_pm.cpp	(revision 658)
+++ trunk/src/gui/text/qfontdatabase_pm.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtGui module of the Qt Toolkit.
Index: trunk/src/gui/text/qfontengine_pm.cpp
===================================================================
--- trunk/src/gui/text/qfontengine_pm.cpp	(revision 658)
+++ trunk/src/gui/text/qfontengine_pm.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtGui module of the Qt Toolkit.
Index: trunk/src/gui/text/qfontengine_pm_p.h
===================================================================
--- trunk/src/gui/text/qfontengine_pm_p.h	(revision 658)
+++ trunk/src/gui/text/qfontengine_pm_p.h	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtGui module of the Qt Toolkit.
Index: trunk/src/gui/util/qdesktopservices_pm.cpp
===================================================================
--- trunk/src/gui/util/qdesktopservices_pm.cpp	(revision 658)
+++ trunk/src/gui/util/qdesktopservices_pm.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtGui module of the Qt Toolkit.
Index: trunk/src/gui/util/qsystemtrayicon_pm.cpp
===================================================================
--- trunk/src/gui/util/qsystemtrayicon_pm.cpp	(revision 658)
+++ trunk/src/gui/util/qsystemtrayicon_pm.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtGui module of the Qt Toolkit.
Index: trunk/src/network/kernel/qhostinfo_os2.cpp
===================================================================
--- trunk/src/network/kernel/qhostinfo_os2.cpp	(revision 658)
+++ trunk/src/network/kernel/qhostinfo_os2.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtNetwork module of the Qt Toolkit.
Index: trunk/src/network/kernel/qnetworkinterface_os2.cpp
===================================================================
--- trunk/src/network/kernel/qnetworkinterface_os2.cpp	(revision 658)
+++ trunk/src/network/kernel/qnetworkinterface_os2.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtNetwork module of the Qt Toolkit.
Index: trunk/src/network/socket/qlocalserver_os2.cpp
===================================================================
--- trunk/src/network/socket/qlocalserver_os2.cpp	(revision 658)
+++ trunk/src/network/socket/qlocalserver_os2.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtNetwork module of the Qt Toolkit.
Index: trunk/src/network/socket/qlocalsocket_os2.cpp
===================================================================
--- trunk/src/network/socket/qlocalsocket_os2.cpp	(revision 658)
+++ trunk/src/network/socket/qlocalsocket_os2.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtNetwork module of the Qt Toolkit.
Index: trunk/src/network/socket/qnativesocketengine_os2.cpp
===================================================================
--- trunk/src/network/socket/qnativesocketengine_os2.cpp	(revision 658)
+++ trunk/src/network/socket/qnativesocketengine_os2.cpp	(revision 659)
@@ -1,9 +1,9 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
 **
-** Copyright (C) 2009 netlabs.org. OS/2 parts.
+** Copyright (C) 2010 netlabs.org. OS/2 parts.
 **
 ** This file is part of the QtNetwork module of the Qt Toolkit.